 // I2C-Communikation bei  4MHz, als Master
 //
 //
 // Michael Dworkin
 // 26.05.2003
 // Compiler CC5x

void bstart(void) {		// Startbedinung generieren
	sda=1;
	tsda=0;					//sda,scl-ausgnge
	tscl=0;
	scl=0;
	nop();
	scl=1;
	nop2();
	nop2();
	nop();
	sda=0;
	nop2();
	nop2();
	nop();
	scl=0;
	nop2();
}

void bstop(void) {		// Stopbedinung generieren
	tsda=0;					//sda,scl-ausgnge
	sda=0;
	nop2();
	nop();
	scl= 1;
	nop2();
	nop();
	sda=1;
	nop2();
	scl= 0;   				//? eigentlich hochomig machen
	nop2();
	nop();
}

bit bitein(void) {		// Ein Bit Einlesen
	bit din;
	tsda=1;					//sda input
	tscl=0;
	sda=1;					// braucht man nicht
	scl=1;
	nop2();
	nop2();
	nop();
	din=sda;
	scl=0;
	return din;
}

void bitaus(bit dout) {	// Ein Bit Schreiben
	tsda=0;					//sda output
	sda=dout;
	nop();
	scl=1;
	nop2();
	nop2();
	scl=0;
}

char lesen(void) {		// Byte empfangen
	char DATAIN, i ;
	for(i=0;i<8;i++) {
		DATAIN =DATAIN<<1;
		if( bitein() ) DATAIN.0=1;
	}
	return DATAIN;
}

bit schreib(char DATAOUT) {
	char i;
	for(i=0;i<8;i++) {
		bitaus(DATAOUT.7 );
		DATAOUT =DATAOUT<<1;
	}
	return bitein();					//if din=1 dann Fehler
}

